<?xml version="1.0"?>
<!-- 
(c)2006 David Sporn

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public
License version 2.1 as published by the Free Software Foundation.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-->

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="text"/>

<!-- Main part -->
<xsl:template match="Linker"><![CDATA[<?php 
//
// DO NOT EDIT ! THIS CODE WAS AUTOMATICALLY GENERATED !
//

require_once("lib/RegularLinkerBase.php") ;

/**]]><xsl:value-of select="@classname"/><![CDATA[.
 * This build links to the following pages :
 * (Name, description)]]><xsl:apply-templates mode="pageDocumentation"/><![CDATA[
 */
class ]]><xsl:value-of select="@classname"/><![CDATA[ extends RegularLinkerBase
{
	//Name of request variables
	var $myParamPrefix ;
	
	var $myTopPage ;]]><xsl:apply-templates mode="varDeclaration"/><![CDATA[
	//Constructor
	function ]]><xsl:value-of select="@classname"/><![CDATA[($baseUrl = '', $baseParam = '')
	{
		$this->myParamPrefix = $baseParam ;
		
		$this->myTopPage = $baseUrl ;
]]><xsl:apply-templates mode="varInitialisation"/><![CDATA[
	}
	
	//Accessors	
	function getTopPage()
	{
		return $this->myTopPage ;
	}
	
]]><xsl:apply-templates mode="getter"/><![CDATA[
}
?>]]>
</xsl:template>

<!-- Property documentation -->
<xsl:template match="page" mode="pageDocumentation"><![CDATA[]]><xsl:value-of select="@name"/><![CDATA[, ]]><xsl:value-of select="description"/><![CDATA[
]]></xsl:template>

<!-- Property declaration -->
<xsl:template match="page" mode="varDeclaration"><![CDATA[var $my]]><xsl:value-of select="@name"/><![CDATA[ ;
]]></xsl:template>

<!-- Property initialisation -->
<xsl:template match="page" mode="varInitialisation"><![CDATA[	$this->my]]><xsl:value-of select="@name"/><![CDATA[ = $baseUrl.'/]]><xsl:value-of select="@path"/><![CDATA[.php' ;
]]></xsl:template>

<!-- Property accessors (default, then specific type value) -->
<xsl:template match="page" mode="getter"><![CDATA[/**]]><xsl:value-of select="description"/><![CDATA[
]]><xsl:apply-templates mode="parameterDoc" select="property"/><![CDATA[
	 * @return a link as a string
	 */
	function get]]><xsl:value-of select="@name"/><![CDATA[(]]><xsl:apply-templates mode="parameterList" select="property"/><![CDATA[)
	{
		$result = $this->my]]><xsl:value-of select="@name"/><xsl:apply-templates mode="parameterUrl" select="property"/><![CDATA[ ;
		return $result ;
	}
]]></xsl:template>

<xsl:template match="property" mode="parameterDoc"><![CDATA[
	 * a]]><xsl:value-of select="@name"/><![CDATA[ = ']]><xsl:value-of select="@defaultValue"/><![CDATA[' ]]><xsl:value-of select="description"/></xsl:template>
<xsl:template match="property" mode="parameterList"><xsl:if test="position()>1"><xsl:value-of select="','"/></xsl:if><![CDATA[$a]]><xsl:value-of select="@name"/><![CDATA[ = ']]><xsl:value-of select="@defaultValue"/><![CDATA[']]></xsl:template>
<xsl:template match="property" mode="parameterUrl"><![CDATA[.$this->encodeParameter($this->myParamPrefix.']]><xsl:value-of select="@name"/><![CDATA[', $a]]><xsl:value-of select="@name"/><xsl:if test="position()=1"><xsl:value-of select="', true'"/></xsl:if><![CDATA[)]]></xsl:template>


</xsl:stylesheet>