<?php
/*
(c)2004,2005 David Sporn

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public
License version 2.1 as published by the Free Software Foundation.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/**
 *Base class for generating links.
 *Contains utility functions.
 */

class LinkerBase
{
	/**Encode a parameter value in a url.
	 * Override this method according your needs.
	 * @param name the parameter name.
	 * @param value the value to encode.
	 * @param isFirst flag set to true if it is the first parameter of the list.
	 * @return a string
	 */
	function encodeParameter($name, $value, $isFirst = false)
	{
		return '' ;
	}

	/**Return a value where some special character have been url-encoded.
	 * @param value the value to encode.
	 * @return a string
	 */
	function encodeValue($value)
	{
		$value = str_replace('&','%26',$value) ;
		$value = str_replace(' ','%20',$value) ;
		return $value ;
	}
	
	/**Encode an url so that it is xml-compliant.
	 * @param value the value to encode.
	 * @return a string
	 */
	function encodeUrl($value)
	{
		return htmlspecialchars($value, ENT_COMPAT) ;
	}
	
}
?>